<template>
  <div class="animation_dialog register">
    <el-dialog
      v-model="showRegisterDialog"
      :before-close="() => toggleLoginRegisterDialog(false)"
      destroy-on-close
      width="100%"
      custom-class="animation-dialog"
      style="border-radius: 8px;"
    >
      <template #title>
        <div class="header-title flex font-bold text-white items-center px-2">
          <p class="text-primary font-[900] text-[16px]">{{ $t("joinnow") }}</p>
        </div>
      </template>
      <div class="px-[16px] bg-1 overflow-scroll h-full">
        <el-form
          ref="formRef"
          label-position="top"
          :rules="formRules"
          :model="formModel"
          class="pb-[110px] sport-register-form"
        >
          <el-form-item
            :class="{ required: rules.Username.required }"
            :label="$t('username')"
            prop="Username"
          >
            <el-input v-model="formModel.Username" />
          </el-form-item>
          <el-form-item
            :class="{ required: rules.Password.required }"
            :label="$t('password')"
            prop="Password"
          >
            <el-input v-model="formModel.Password" :type="inputTypePw">
              <template #suffix>
                <div @click.prevent="showPassword('password')">
                  <font-awesome-icon v-if="isShowPassword" icon="eye-slash" />
                  <font-awesome-icon v-else icon="eye" />
                </div>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item
            :class="{ required: rules.ConfirmPassword.required }"
            :label="$t('confirm_password')"
            prop="ConfirmPassword"
            show-password
          >
            <el-input v-model="formModel.ConfirmPassword" :type="inputTypecfPw">
              <template #suffix>
                <div @click.prevent="showPassword('cfpassword')">
                  <font-awesome-icon v-if="isShowcfPassword" icon="eye-slash" />
                  <font-awesome-icon v-else icon="eye" />
                </div>
              </template>
            </el-input>
          </el-form-item>
          <el-form-item
            :class="{ required: rules.Currency.required }"
            :label="$t('currency')"
            prop="Currency"
          >
            <el-select
              v-model="formModel.Currency"
              style="width: 100%"
              :disabled="currencies.length <= 0"
              class="currency"
            >
              <template v-if="formModel.Currency !== ''" #prefix>
                <i class="el-icon el-input__icon tick">
                  <svg-icon
                    svg-name="circle-check"
                    class-name="el-form-item.is-success i.el-input__validateIcon object-contain curreny-icon-tick"
                  />
                </i>
              </template>
              <el-option
                v-for="currency in currencies"
                :key="currency"
                :label="currency.Currency"
                :value="String(currency.Currency)"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <template v-for="property in availableProperties" :key="property.PropertyName">
          <theme-common-otp-field
            v-if="property.PropertyName === 'Phone'"
            v-model="formModel"
            :label="property.PropertyNameForDisplay"
            :phone-property="property.PropertyName"
            :is-required="rules[property.PropertyName].required"
            :loading="isGettingOtpCode"
            :next-request-in-seconds="nextRequestOtpInSeconds"
            @get-code="onGetVerificationCode"
          >
            <template #phone>
              <el-form-item
                :label="property.PropertyNameForDisplay"
                :prop="property.PropertyName"
                :class="{ required: rules[property.PropertyName].required }"
              >
                <el-input
                  v-model="formModel[property.PropertyName]"
                  :formatter="(value: string) => value" 
                  :parser="(value: string) => value.replace(/\D+/g, '')"
                >
                  <template #suffix>
                    <el-tooltip
                      class="box-item"
                      effect="dark"
                      :content="
                        $t(
                          'valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes'
                        )
                      "
                      placement="bottom"
                    >
                      <el-icon class="el-input__icon info" color="var(--primary)">
                        <info-filled />
                      </el-icon>
                    </el-tooltip>
                  </template>
                </el-input>
              </el-form-item>
            </template>
          </theme-common-otp-field>
          <el-form-item
            v-else
            :label="property.PropertyNameForDisplay"
            :prop="property.PropertyName"
            :class="{ required: rules[property.PropertyName].required }"
          >
            <el-select
              v-if="property.PropertyName === 'Bank'"
              v-model="formModel.Bank"
              style="width: 100%"
              :disabled="bankOptions.length <= 0"
            >
              <el-option
                v-for="bank in bankOptions"
                :key="bank.Id"
                :label="bank.BankName"
                :value="String(bank.Id)"
              >
                <div class="flex justify-between w-full">
                  <div class="flex items-center">
                    <div>
                      {{ bank.BankName }}
                    </div>
                    <div class="w-[16px] ml-[11px] bank-check-icon">
                      <font-awesome-icon icon="circle-check" />
                    </div>
                  </div>
                </div>
              </el-option>
            </el-select>
            <div v-else-if="property.PropertyName === 'Gender'">
              <el-radio v-model="formModel.Gender" label="male">{{
                $t("male")
              }}</el-radio>
              <el-radio v-model="formModel.Gender" label="female">{{
                $t("female")
              }}</el-radio>
            </div>
            <el-date-picker
              v-else-if="property.PropertyName === 'DateOfBirth'"
              v-model="formModel.DateOfBirth"
              type="date"
              value-format="YYYY-MM-DD"
            />
            <el-input 
            v-else-if="property.PropertyName === 'Mobile'" 
            v-model="formModel[property.PropertyName]" 
            :formatter="(value: string) => value" 
            :parser="(value: string) => value.replace(/\D+/g, '')"></el-input>
            <el-input
              v-else-if="property.PropertyName === 'Referral'"
              v-model="formModel[property.PropertyName]"
              :disabled="referralQuery.length"
            ></el-input>
            <el-input
              v-else-if="property.PropertyName === 'BankAccountName'"
              v-model="formModel[property.PropertyName]"
              :disabled="formModel.Bank === '0' || formModel.Bank === ''"
            ></el-input>
            <el-input
              v-else-if="property.PropertyName === 'BankAccountNumber'"
              v-model="formModel[property.PropertyName]"
              :disabled="formModel.Bank === '0' || formModel.Bank === ''"
              :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')"
            ></el-input>
            <el-input
              v-else
              v-model="formModel[property.PropertyName]"
            ></el-input>
          </el-form-item>
          </template>
          <el-form-item
            v-if="cashAgentQuery && cashAgentQuery.length"
            :label="$t('agent_name')"
            prop="AgentName"
          >
            <el-input
              v-model="formModel.AgentName"
              :disabled="cashAgentQuery.length"
            />
          </el-form-item>
          <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha" :label="$t('enter_validation_code')">
            <div class="captcha">
              <captcha
                :value="formModel.Captcha"
                @isValid="getCaptchaErrorMsg"
              />
              <el-input
                v-model="formModel.Captcha"
                type="text"
                class="captcha-input"
              />
            </div>
          </el-form-item>
        </el-form>
        
        <div class="absolute bottom-0 left-0 w-full h-[110px] bg-[var(--background5)]">
            <div class="flex justify-center px-4">
              <div class="pt-5 w-full flex justify-center" style="border-top: 1px solid var(--border);">
                <el-button
                  :loading="isLoading"
                  type="primary"
                  round
                  @click="onRegister(formRef)"
                  >{{ $t("submit") }}</el-button
                >
              </div>
            </div>
            <p class="mt-4 text-center text-sm leading-4 font-normal mb-4">
              {{ $t("already_have_an_account") }} ?
              <span class="text-primary" @click="toggleLoginRegisterDialog()">{{
                $t("log_in")
              }}</span>
            </p>
            </div>
      </div>
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from "vue";
// import { VueRecaptcha } from "vue-recaptcha";
import useRegister from "@/composables/useRegister";
import { store } from "@/store";

export default defineComponent({
  components: {
    // reCaptcha: VueRecaptcha,
  },
  setup() {
    const { toggleLoginRegisterDialog } = commonHelper;
    const showRegisterDialog = computed(() => store.state.showRegisterDialog);
    const inputTypePw = ref("password");
    const inputTypecfPw = ref("password");
    const isShowPassword = ref(false);
    const isShowcfPassword = ref(false);
    const showPassword = (input: string) => {
      if (input === "password" && inputTypePw.value === "text") {
        inputTypePw.value = "password";
        isShowPassword.value = false;
      } else if (input === "password" && inputTypePw.value === "password") {
        inputTypePw.value = "text";
        isShowPassword.value = true;
      } else if (input === "cfpassword" && inputTypecfPw.value === "text") {
        inputTypecfPw.value = "password";
        isShowcfPassword.value = false;
      } else {
        inputTypecfPw.value = "text";
        isShowcfPassword.value = true;
      }
    };
    const {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      isLoading,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    return {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      showRegisterDialog,
      isShowcfPassword,
      isShowPassword,
      inputTypePw,
      inputTypecfPw,
      showPassword,
      isLoading,
      rules,
      toggleLoginRegisterDialog,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    };
  },
});
</script>

<style scoped>
:deep(.otp-field > .el-button) {
  width: unset;
}
.el-form-item.is-error.verify__recaptcha__success
  > :where(.el-form-item__content)
  > :deep(.el-form-item__error) {
  display: none;
}
:deep(.el-dialog) {
  --el-dialog-bg-color: var(--background5);
}
:deep(.el-dialog__headerbtn .el-dialog__close) {
  color: var(--text5);
}
:deep(.el-dialog__headerbtn) {
  top: 2px;
}
:deep(.main__bg) {
  background: rgba(0, 0, 0, 0.2);
  border-bottom: 1px solid var(--border);
  padding: 16px;
  margin-top: 32px;
}
:deep(.el-form--label-top) {
  @apply mt-3;
}
:deep(.el-dialog__header) {
  padding: 16px;
  background: rgba(0, 0, 0, 0.2);
  margin-right: 0px;
  margin-top: 32px;
  border-bottom: 2px solid var(--border);
}
:deep(.el-dialog__body) {
  background: var(--background5);
  height: calc(100vh - 93px);
}
.el-select-dropdown .svg-inline--fa {
  color: var(--hint);
}
:deep(.el-input__inner) {
  background: rgba(0, 0, 0, 0.1);
  height: 40px !important;
  border-radius: 4px;
}
:deep(.el-form-item:not(.is-error) .el-input__inner:hover), :deep(.el-form-item:not(.is-error) .el-select:hover .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--border) inset !important;
}
:deep(.el-form-item:not(.is-error) .el-input__inner:focus), :deep(.el-form-item:not(.is-error) .el-select .el-input.is-focus .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--selected) inset !important;
}
.bg-1 {
  background-color: var(--background5);
}
.el-button.el-button--primary {
  --el-button-text-color: var(--textBtn);
  --el-button-bg-color: rgb(49, 196, 110);
  --el-button-border-color: rgb(49, 196, 110);
  --el-button-hover-text-color: var(--textBtn);
  --el-button-hover-bg-color: rgb(107, 82, 203);
  --el-button-hover-border-color: rgb(107, 82, 203);
}
.el-input {
  --el-input-focus-border-color: rgb(49, 196, 110);
}
.text-primary {
  color: var(--primary);
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4;
}
.selected .currency-check-icon {
  display: block;
}
.currency-check-icon {
  display: none;
}
.selected .bank-check-icon {
  display: block;
}
.bank-check-icon {
  display: none;
}

.sport-register-form :deep(.el-form-item) {
  margin-bottom: 16px;
}
.captcha {
  width: 100%;
  display: flex;
  gap: 0.5rem;
}
.vue_client_recaptcha {
  height: 32px;
  min-width: 128px;
}
:deep(.vue_client_recaptcha_icon) {
  height: 32px;
  width: fit-content;
  order: 2;
}
:deep(.vue_client_recaptcha_icon img) {
  width: 32px !important;
  height: 32px !important;
}
:deep(.vue_client_recaptcha .captcha_canvas) {
  width: 96px;
  height: 32px;
  order: 1;
  padding: 0;
}
:deep(.captcha-input .el-input__inner) {
  height: 32px !important;
}
:deep(.el-input__suffix) {
  @apply flex items-center;
}
[theme-color="bk8"] .info {
  color: var(--success);
}
[theme-color="bk8"] .animation_dialog.register .title {
  color: var(--text5);
}
:deep(button.el-button) {
  width: 328px;
  background-color: var(--secondary);
  border: none;
  border-radius: 4px;
}
.animation_dialog.register {
  outline: none;
}
</style>
<style lang="scss">
.animation-dialog {
  .el-dialog__headerbtn {
    top: 3px;
    .el-icon {
      width: auto;
      height: auto;
      border-radius: 50%;
      background-color: var(--primary);
      svg {
        width: 20px;
        height: 20px;
        color: black;
        padding: 2px;
      }
    }
  }
  .currency .el-input__prefix {
    z-index: 10;
    right: 12px;
    left: unset;
    svg {
      fill: var(--primary);
    }
  }
  .currency .el-input__suffix {
    right: 32px;
  }
  .currency .el-input--prefix .el-input__inner {
    padding-left: 10px;
  }
}
</style>
